function U=lap2d(A,f,G1,G2,G3,G4,X,Y,h)

[n,m]=size(X);
n=n-2;
m=m-2;

% Second membre (calculé sur les noeuds interieurs)
F=f(X(2:end-1,2:end-1),Y(2:end-1,2:end-1));

% Conditions aux limites
F(end,:)=F(end,:)+G1(2:end-1)/h/h;
F(1,:)=F(1,:)+G3(2:end-1)/h/h;
F(:,1)=F(:,1)+G4(2:end-1)/h/h;
F(:,end)=F(:,end)+G2(2:end-1)/h/h;
F=reshape(flipud(F)',n*m,1);

% Resolution du systeme
U=A\F;
U=flipud(reshape(U,m,n)');
U=[G4,[G3(2:end-1);U;G1(2:end-1)],G2];
